unit testMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, PaintMap, StdCtrls, mapObject, ExtCtrls, mapLayer,
  ImgList, data, ComCtrls, ToolWin;

type
  TForm1 = class(TForm)
    Panel4: TPanel;
    StatusBar1: TStatusBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ImageList1: TImageList;
    ToolButton4: TToolButton;
    Panel1: TPanel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Label3: TLabel;
    Label6: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label1: TLabel;
    Panel2: TPanel;
    TabSheet2: TTabSheet;
    Panel3: TPanel;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox4: TCheckBox;
    Label5: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    PM: TPaintMap;
    Label11: TLabel;
    Label12: TLabel;
    Timer1: TTimer;
    procedure FormShow(Sender: TObject);
    procedure TBItem5Click(Sender: TObject);
    procedure PMHotObject(hotObject: TMapObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure PMDblClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private

  protected
    regs: TMapLayer;
    railways: TMapLayer;
    towns: TMapLayer;
    
    car: TMapObject;
    procedure CreateRegions;
    procedure CreateRailWays;
    procedure CreateTowns;

    function CreateRegion(layer: TMapLayer;
      Points: array of TPoint; color, colorHot: TColor): TMapObject;

    function CreateTown(layer: TMapLayer; TownName: string; radius, x, y: integer; xCap, yCap: integer) : TMapObject;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormShow(Sender: TObject);
var
tmp, tmp2: TMapObject;
begin
  PM.Mode := PMM_ARROW;

  CreateRegions;
  CreateRailWays;
  CreateTowns;

  tmp := TMapObject.Create;
  tmp.LoadNormalFromEmf('img1.emf');

  tmp2 := towns.Insert(tmp);
  tmp2.Position := Point(100, 0);

  tmp.Free;

  pm.ZoomToAll;
end;

function TForm1.CreateRegion(layer: TMapLayer;
  Points: array of TPoint; color, colorHot: TColor): TMapObject;
begin
  Result := layer.Insert;
  Result.BeginPaintAsNormal(true);
  Result.Canvas.Brush.Style := bsSolid;
  Result.Canvas.Brush.Color := color;
  Result.Canvas.Pen.Width := 0;
  Result.Canvas.Polygon(Points);
  Result.EndPaint;

  Result.BeginPaintAsHot(true);
  Result.Canvas.Brush.Style := bsSolid;
  Result.Canvas.Brush.Color := color;
  Result.Canvas.Pen.Width := 3;
  Result.Canvas.Pen.Color := clBlue;
  Result.Canvas.Polygon(Points);
  Result.EndPaint;

  Result.BeginPaintAsSelect(true);
  Result.Canvas.Brush.Style := bsSolid;
  Result.Canvas.Brush.Color := clred;//(color or RGB(50, 50, 50));
  Result.Canvas.Pen.Width := 0;
  Result.Canvas.Polygon(Points);
  Result.EndPaint;                  

  Result.SetActiveZone(Points);
end;

procedure TForm1.TBItem5Click(Sender: TObject);
begin
  PM.ZoomToAll;
end;

procedure TForm1.PMHotObject(hotObject: TMapObject);
begin
  if hotObject <> nil then
  try
    StatusBar1.Panels[0].Text := hotObject.GetPropertyValue('Name')
  except
    StatusBar1.Panels[0].Text := 'Object does not allow ''Name'' property';
  end
  else
    StatusBar1.Panels[0].Text := 'No active objects';
end;

procedure TForm1.ToolButton1Click(Sender: TObject);
begin
  if ToolButton1.Down then
    PM.Mode := PMM_ARROW;
end;

procedure TForm1.ToolButton2Click(Sender: TObject);
begin
  if ToolButton2.Down then
    PM.Mode := PMM_INC;
end;

procedure TForm1.ToolButton3Click(Sender: TObject);
begin
  if ToolButton3.Down then
    PM.Mode := PMM_DEC;
end;

procedure TForm1.ToolButton4Click(Sender: TObject);
begin
  PM.ZoomToAll;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  regs.visible := CheckBox1.Checked;
  PM.Repaint;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  railWays.visible := CheckBox2.Checked;
  PM.Repaint;
end;

procedure TForm1.CreateRegions;
var
tmp: TMapObject;
begin
  regs := pm.InsertLayer;
  regs.name := 'Regions';
  tmp := CreateRegion(regs, Polygon1, RGB(200, 255, 200), RGB(220, 255, 220));
  tmp.Tag := 1; tmp.AddProperty('Name', 'Region #1');
  tmp := CreateRegion(regs, Polygon2, RGB(200, 200, 255), RGB(220, 220, 255));
  tmp.Tag := 2; tmp.AddProperty('Name', 'Region #2');
  tmp := CreateRegion(regs, Polygon3, RGB(255, 200, 200), RGB(255, 220, 220));
  tmp.Tag := 3; tmp.AddProperty('Name', 'Region #3');
  tmp := CreateRegion(regs, Polygon4, RGB(255, 255, 200), RGB(255, 255, 220));
  tmp.Tag := 4; tmp.AddProperty('Name', 'Region #4');
  tmp := CreateRegion(regs, Polygon5, RGB(200, 255, 255), RGB(220, 255, 255));
  tmp.Tag := 5; tmp.AddProperty('Name', 'Region #5');
  tmp := CreateRegion(regs, Polygon6, RGB(150, 250, 250), RGB(170, 255, 255));
  tmp.Tag := 6; tmp.AddProperty('Name', 'Region #6');
  tmp := CreateRegion(regs, Polygon7, RGB(250, 150, 250), RGB(255, 170, 255));
  tmp.Tag := 7; tmp.AddProperty('Name', 'Region #7');
  tmp := CreateRegion(regs, Polygon8, RGB(250, 255, 50), RGB(255, 255, 70));
  tmp.Tag := 8; tmp.AddProperty('Name', 'Region #8');
  tmp := CreateRegion(regs, Polygon9, RGB(50, 255, 150), RGB(70, 255, 170));
  tmp.Tag := 9; tmp.AddProperty('Name', 'Region #9');
  tmp := CreateRegion(regs, Polygon10, RGB(250, 50, 200), RGB(255, 70, 220));
  tmp.Tag := 10; tmp.AddProperty('Name', 'Region #10');
  tmp := CreateRegion(regs, Polygon11, RGB(200, 255, 50), RGB(220, 255, 70));
  tmp.Tag := 11; tmp.AddProperty('Name', 'Region #11');
  tmp := CreateRegion(regs, Polygon12, RGB(50, 250, 250), RGB(70, 255, 255));
  tmp.Tag := 12; tmp.AddProperty('Name', 'Region #12');
  tmp := CreateRegion(regs, Polygon13, RGB(255, 10, 255), RGB(255, 30, 255));
  tmp.Tag := 13; tmp.AddProperty('Name', 'Region #13');
  tmp := CreateRegion(regs, Polygon14, RGB(200, 255, 200), RGB(220, 255, 220));
  tmp.Tag := 14; tmp.AddProperty('Name', 'Region #14');
  tmp := CreateRegion(regs, Polygon15, clCream, clCream);
  tmp.Tag := 15; tmp.AddProperty('Name', 'Region #15');
  tmp := CreateRegion(regs, Polygon16, clMoneyGreen, clMoneyGreen);
  tmp.Tag := 16; tmp.AddProperty('Name', 'Region #16');
  tmp := CreateRegion(regs, Polygon17, clSkyBlue, clSkyBlue);
  tmp.Tag := 17; tmp.AddProperty('Name', 'Region #17');
  tmp := CreateRegion(regs, Polygon18, clYellow, clYellow);
  tmp.Tag := 18; tmp.AddProperty('Name', 'Region #18');
end;

procedure TForm1.CreateRailWays;
const lines: array[1..40] of integer = (
  -50, 0, 100, 100,
  100, 100, 220, 180,
  220, 180, 250, 300,
  220, 180, 350, 190,
  100, 100, 50, 250,
  -50, 0, -70, -100,
  -70, -100, -200, -200,
  -70, -100, 150, -150,
  -200, -200, -330, -400,
  -50, 0, -200, 200
);
var
tmp: TMapObject;
i: integer;

begin
  railWays := PM.InsertLayer;
  railWays.name := 'Rail ways';
  //create railway between towns
  tmp := railWays.Insert;
  tmp.BeginPaintAsNormal(true);
  tmp.Canvas.Pen.Style := psSolid;
  tmp.Canvas.Pen.Width := 3;

  i := 1;
  while i < Length(lines) do
  begin
    tmp.Canvas.MoveTo(lines[i], lines[i + 1]);
    tmp.Canvas.LineTo(lines[i + 2], lines[i + 3]);
    i := i + 4;
  end;

  tmp.Canvas.Font.Name := 'Times New Roman';
  tmp.Canvas.Font.Size := 18;
  tmp.Canvas.Font.Style := [fsBold];
  tmp.Canvas.TextOut(350, 170, 'To the east');  
  tmp.EndPaint;

end;

procedure TForm1.CreateTowns;
begin
  towns := PM.InsertLayer;
  towns.name := 'Towns';

  CreateTown(towns, 'Town #1', 10, -50, 0, 5, -20);
  CreateTown(towns, 'Town #2', 10, 100, 100, 5, -20);
  CreateTown(towns, 'Town #2', 10, 220, 180, 5, -20);
  CreateTown(towns, 'Town #2', 10, 250, 300, 5, -20);
  CreateTown(towns, 'Town #2', 10, 100, 100, 5, -20);
  CreateTown(towns, 'Town #2', 10, 50, 250, 5, -20);
  CreateTown(towns, 'Town #2', 10, -70, -100, 5, -20);
  CreateTown(towns, 'Town #2', 10, -200, -200, 5, -20);
  CreateTown(towns, 'Town #2', 10, -200, 200, 5, -20);
  CreateTown(towns, 'Town #2', 10, 150, -150, 5, -20);
  CreateTown(towns, 'Town #2', 10, -330, -400, 5, -20);  
end;

function TForm1.CreateTown(layer: TMapLayer; TownName: string; radius, x,
  y, xCap, yCap: integer): TMapObject;
var
newObj: TMapObject;
begin

  newObj := layer.Insert;
  with newObj do
  begin
    Position := Point(x, y);
    BeginPaintAsNormal(true);
    canvas.Pen.Width := 1;
    canvas.Pen.Color := clBlack;
    canvas.Ellipse(-radius, -radius, radius, radius);
    SetTextAlign(canvas.Handle, TA_LEFT);
    SetBkMode(canvas.Handle, TRANSPARENT);
    canvas.Font.Name := 'Times New Roman';
    canvas.Font.Color := clBlack;
    canvas.Font.Style := [];
    canvas.TextOut(xCap, yCap, TownName);
    EndPaint;

    BeginPaintAsHot(true);
    canvas.Pen.Width := 2;
    canvas.Pen.Color := clRed;
    canvas.Ellipse(-radius, -radius, radius, radius);
    SetTextAlign(canvas.Handle, TA_LEFT);
    SetBkMode(canvas.Handle, TRANSPARENT);
    canvas.Font.Name := 'Times New Roman';
    canvas.Font.Color := clBlack;
    canvas.Font.Style := [];
    canvas.Brush.Color := clInfoBK;
    canvas.Pen.Width := 1;
    canvas.Pen.Color := clBlack;
    canvas.Rectangle(xCap - 2, yCap - 2, xCap + canvas.TextWidth(TownName) + 2, yCap + canvas.TextHeight(TownName));
    canvas.TextOut(xCap, yCap, TownName);
    EndPaint;

    AddProperty('Name', TownName);

    SetActiveZone([Point(x-radius, y-radius), Point(x + radius, y-radius),
      Point(x+radius, y+radius), Point(x-radius, y+radius)]);
  end;

  Result := newObj;
end;

procedure TForm1.CheckBox4Click(Sender: TObject);
begin
  Towns.visible := CheckBox4.Checked;
  PM.Repaint;
end;

procedure TForm1.PMDblClick(Sender: TObject);
var
obj: TMapObject;
begin
  obj := PM.GetHotObject;
  if obj = nil then
    exit;
  PM.ZoomToLogRect(obj.ClipRect);
  PM.Repaint;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if PageControl1.TabIndex = 1 then
  begin
    TabSheet2.Caption := 'Layers';
    Timer1.Enabled := false;
    exit;
  end;
  if TabSheet2.Caption = 'Layers' then
    TabSheet2.Caption := 'LAYERS'
  else
    TabSheet2.Caption := 'Layers';
end;

end.
